"""
Copyright (c) 2008, Carl Scheffler
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * The name of the copyright owner may not be used to endorse or promote
      products derived from this software without specific prior written
      permission.

THIS SOFTWARE IS PROVIDED BY <copyright holder> ``AS IS'' AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <copyright holder> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

"""
Last modified: 3 April 2006

This part of the library is now deprecated and is here for backwards
compatibility only. It will be removed completely in future.

FabSim: Functions for simulating the Camm, Epilog and Modela machines
        in a FabLab.
"""

from __future__ import division

def simulate_epi(filename, plot = True):
   import sys
   from render import render_epi

   # Load file
   if filename == '':
      infile = sys.stdin
   else:
      infile = file(filename, 'rt')
   commands = infile.read()
   if filename != '': infile.close()
   return render_epi(commands)

def simulate_camm(filename, plot = True):
   import sys
   from render import render_camm

   # Load file
   if filename == '':
      infile = sys.stdin
   else:
      infile = file(filename, 'rt')
   commands = infile.read()
   if filename != '': infile.close()
   return render_camm(commands)

def simulate_modela(filename, plot = True):
    import sys
    from render import render_rml

    # Load file
    if filename == '':
        infile = sys.stdin
    else:
        infile = file(filename, 'rt')
    commands = infile.read()
    if filename != '': infile.close()
    return render_rml(commands)
